import '../assets/MazStepper.css';
import { defineComponent as J, useCssVars as K, defineAsyncComponent as v, computed as h, useSlots as Q, ref as U, openBlock as a, createElementBlock as c, Fragment as y, renderList as X, normalizeClass as A, createElementVNode as d, createBlock as z, resolveDynamicComponent as P, createCommentVNode as l, renderSlot as m, unref as W, createTextVNode as g, toDisplayString as $, createVNode as Y, withCtx as Z } from "vue";
const ee = { class: "m-stepper" }, te = ["id", "disabled", "onClick"], oe = { class: "m-stepper__header__wrapper" }, ne = { class: "m-stepper__count --primary" }, se = { class: "m-stepper__count__circle" }, ae = { class: "m-stepper__header__content" }, le = { class: "m-stepper__title" }, re = {
  key: 0,
  class: "m-stepper__subtitle"
}, ie = {
  key: 0,
  class: "m-stepper__right"
}, ce = { class: "m-stepper__content__wrapper" }, de = /* @__PURE__ */ J({
  __name: "MazStepper",
  props: {
    modelValue: { default: void 0 },
    steps: { default: void 0 },
    color: { default: "primary" },
    disabledNextSteps: { type: Boolean },
    disabledPreviousSteps: { type: Boolean },
    autoValidateSteps: { type: Boolean },
    allStepsOpened: { type: Boolean },
    allStepsValidated: { type: Boolean },
    canCloseSteps: { type: Boolean }
  },
  emits: ["update:model-value"],
  setup(f, { emit: C }) {
    K((t) => ({
      "48abb4c8": R.value,
      "30b55634": q.value
    }));
    const b = v(() => import("./MazIcon-Cxrv3_OK.mjs")), k = v(() => import("./MazExpandAnimation-BK8NZV2H.mjs")), I = v(() => import("./check-circle-CtCMBYyp.mjs")), T = v(
      () => import("./exclamation-circle-DzBJ8vGa.mjs")
    ), j = v(() => import("./exclamation-triangle-BfZLmRbP.mjs")), n = f, L = C, R = h(() => `var(--maz-color-${n.color})`), q = h(() => `var(--maz-color-${n.color}-contrast)`), E = Q(), S = h(
      () => Object.keys(E).filter((t) => t.startsWith("content-")).length
    ), N = U(1), s = h({
      get: () => n.modelValue ?? N.value,
      set: (t) => {
        N.value = t, L("update:model-value", t);
      }
    }), V = (t) => F(t) ? { icon: I, class: "--success" } : w(t) ? { icon: j, class: "--warning" } : O(t) ? { icon: T, class: "--error" } : { class: "--normal" };
    function p(t) {
      var o, e;
      return (e = (o = n.steps) == null ? void 0 : o[t - 1]) == null ? void 0 : e.icon;
    }
    const x = (t, o) => {
      var e, r;
      return (r = (e = n.steps) == null ? void 0 : e[o - 1]) == null ? void 0 : r[t];
    }, B = (t) => {
      s.value === t && n.canCloseSteps ? s.value = 0 : t < 1 ? s.value = 1 : t > S.value ? s.value = S.value : s.value = t;
    }, D = (t, o) => {
      var i, _;
      const e = t === "titleInfo" ? "title-info" : t, r = Object.keys(E).filter((H) => H.startsWith(`${e}-`)).includes(`${e}-${o}`), u = !!((_ = (i = n.steps) == null ? void 0 : i[o - 1]) != null && _[t]);
      return r || u;
    }, F = (t) => {
      var u, i;
      const o = (i = (u = n.steps) == null ? void 0 : u[t - 1]) == null ? void 0 : i.success, e = O(t) || w(t), r = n.autoValidateSteps && t < s.value && !e;
      return o ?? (r || n.allStepsValidated);
    }, M = (t) => {
      var i, _;
      const o = (_ = (i = n.steps) == null ? void 0 : i[t - 1]) == null ? void 0 : _.disabled, e = s.value === t && !n.canCloseSteps, r = n.disabledNextSteps && t > s.value, u = n.disabledPreviousSteps && t < s.value;
      return o ?? (e || r || u || n.allStepsOpened);
    }, O = (t) => {
      var o, e;
      return (e = (o = n.steps) == null ? void 0 : o[t - 1]) == null ? void 0 : e.error;
    }, w = (t) => {
      var o, e;
      return (e = (o = n.steps) == null ? void 0 : o[t - 1]) == null ? void 0 : e.warning;
    }, G = (t) => t === S.value;
    return (t, o) => (a(), c("div", ee, [
      (a(!0), c(
        y,
        null,
        X(S.value, (e) => (a(), c(
          y,
          { key: e },
          [
            D("title", e) ? (a(), c("button", {
              key: 0,
              id: `header-step-${e}`,
              type: "button",
              disabled: M(e),
              class: A(["m-stepper__header", [
                {
                  "--is-current-step": e === s.value || t.allStepsOpened,
                  "--disabled": e !== s.value && !t.allStepsOpened && M(e)
                },
                `${V(e).class}`
              ]]),
              onClick: (r) => B(e)
            }, [
              d("div", oe, [
                d("span", ne, [
                  d("div", se, [
                    V(e).icon ? (a(), z(P(V(e).icon), {
                      key: 0,
                      class: "icon maz-text-xl"
                    })) : l("v-if", !0)
                  ]),
                  l(`
              @slot icon-\${step} - Replace step number in the circle by an icon for the step
            `),
                  m(t.$slots, `icon-${e}`, {}, () => [
                    p(e) ? (a(), c(
                      y,
                      { key: 0 },
                      [
                        typeof p(e) == "string" ? (a(), z(W(b), {
                          key: 0,
                          name: p(e)
                        }, null, 8, ["name"])) : p(e) ? (a(), z(P(p(e)), { key: 1 })) : l("v-if", !0)
                      ],
                      64
                      /* STABLE_FRAGMENT */
                    )) : (a(), c(
                      y,
                      { key: 1 },
                      [
                        g(
                          $(e),
                          1
                          /* TEXT */
                        )
                      ],
                      64
                      /* STABLE_FRAGMENT */
                    ))
                  ], !0)
                ]),
                d("div", ae, [
                  d("span", le, [
                    l(`
                @slot title-\${step} - Title of the step
              `),
                    m(t.$slots, `title-${e}`, {}, () => [
                      g(
                        $(x("title", e)),
                        1
                        /* TEXT */
                      )
                    ], !0)
                  ]),
                  D("subtitle", e) ? (a(), c("span", re, [
                    l(`
                @slot title-\${step} - Subtitle of the step
              `),
                    m(t.$slots, `subtitle-${e}`, {}, () => [
                      g(
                        $(x("subtitle", e)),
                        1
                        /* TEXT */
                      )
                    ], !0)
                  ])) : l("v-if", !0)
                ])
              ]),
              D("titleInfo", e) ? (a(), c("span", ie, [
                l(`
            @slot title-info-\${step} - Info of the right of the step
          `),
                m(t.$slots, `title-info-${e}`, {}, () => [
                  g(
                    $(x("titleInfo", e)),
                    1
                    /* TEXT */
                  )
                ], !0)
              ])) : l("v-if", !0)
            ], 10, te)) : l("v-if", !0),
            d(
              "div",
              {
                class: A(["m-stepper__content", {
                  "--no-border": G(e)
                }])
              },
              [
                Y(W(k), {
                  "model-value": t.allStepsOpened || s.value === e,
                  "aria-labelledby": `header-step-${e}`
                }, {
                  default: Z(() => [
                    d("div", ce, [
                      l(` @slot content-\${step} - Content of the step
                @binding {boolean} validated - If the step is validated
                @binding {boolean} error - If the step has an error
                @binding {boolean} warning - If the step has a warning
                @binding {Function} previous-step - Function to go to the previous step
                @binding {Function} next-step - Function to go to the next step
              `),
                      m(t.$slots, `content-${e}`, {
                        validated: F(e),
                        error: O(e),
                        warning: w(e),
                        nextStep: () => B(e + 1),
                        previousStep: () => B(e - 1)
                      }, void 0, !0)
                    ])
                  ]),
                  _: 2
                  /* DYNAMIC */
                }, 1032, ["model-value", "aria-labelledby"])
              ],
              2
              /* CLASS */
            )
          ],
          64
          /* STABLE_FRAGMENT */
        ))),
        128
        /* KEYED_FRAGMENT */
      ))
    ]));
  }
}), ue = (f, C) => {
  const b = f.__vccOpts || f;
  for (const [k, I] of C)
    b[k] = I;
  return b;
}, _e = /* @__PURE__ */ ue(de, [["__scopeId", "data-v-b5da572b"]]);
export {
  _e as M,
  ue as _
};
